//+------------------------------------------------------------------+
//|                                                       KPrmSt.mq4 |
//|                                         Copyright  2010, LeMan. |
//|                                                 b-market@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, LeMan."
#property link      "b-market@mail.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_minimum 0
#property indicator_maximum 100
//---- input parameters
extern string TimeFrame       = "Current time frame";
extern int    Per1            = 14;
extern int    Per2            = 3; 
extern int    Per3            = 3;
extern int    Per4            = 5;

extern int    levelOs         = 20;
extern int    levelOb         = 80;       
   
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   alertsOnSignalCross = false;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double TempBuffer[];
double MinBuffer[];
double MaxBuffer[];
double trend[];

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,TempBuffer);
   SetIndexBuffer(3,MinBuffer);
   SetIndexBuffer(4,MaxBuffer);
   SetIndexBuffer(5,trend);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
   SetLevelValue(2,50);
   SetIndexDrawBegin(0,Per1*3);
   SetIndexDrawBegin(1,Per1*3);
   
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
   IndicatorShortName(timeFrameToString(timeFrame)+" KPrmSt ("+Per1+","+Per2+","+Per3+","+Per4+")");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(int i = limit; i >= 0; i--)
      {
         MaxBuffer[i] = iHigh(NULL, 0, iHighest(NULL, 0, MODE_HIGH, Per4, i));
         MinBuffer[i] = iLow(NULL, 0, iLowest(NULL, 0, MODE_LOW, Per4, i));
         int sh = ArrayMaximum(MaxBuffer,Per1,i);
         int sl = ArrayMinimum(MinBuffer,Per1,i);
            TempBuffer[i] = NormalizeDouble((Close[i]-MinBuffer[sl])/(MaxBuffer[sh]-MinBuffer[sl])*100,Digits);
      }
      
      for (i=limit;i>=0;i--) ExtMapBuffer1[i] = NormalizeDouble(iMAOnArray(TempBuffer,Bars, Per2, 0, MODE_EMA, i),Digits);
      for (i=limit;i>=0;i--) 
      {
         ExtMapBuffer2[i] = NormalizeDouble(iMAOnArray(ExtMapBuffer1, Bars, Per3, 0, MODE_EMA, i),Digits);
         trend[i] = trend[i+1];
         if (alertsOnSignalCross)
         {
           if (ExtMapBuffer1[i] < ExtMapBuffer2[i]) trend[i] = -1;
           if (ExtMapBuffer1[i] > ExtMapBuffer2[i]) trend[i] =  1;
         }
         else
         {
           if (ExtMapBuffer1[i] < levelOs) trend[i] = -1;
           if (ExtMapBuffer1[i] > levelOb) trend[i] =  1;
         }           
     }
      manageAlerts();  
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         ExtMapBuffer1[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per1,Per2,Per3,Per4,levelOs,levelOb,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsOnSignalCross,0,y);
         ExtMapBuffer2[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Per1,Per2,Per3,Per4,levelOs,levelOb,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsOnSignalCross,1,y);
   }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      Comment(trend[whichBar],"      ",trend[whichBar+1]);
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar]== 1) doAlert(whichBar,"buy");
         if (trend[whichBar]==-1) doAlert(whichBar,"sell");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" KPrmSt "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," KPrmSt "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

